moGuiExtras = {};

local abs, ceil, floor, max, min, random, pow = math.abs, math.ceil, math.floor, math.max, math.min, math.random, math.pow;
function moGuiExtras:setFirstDisplayZoom(self)
	if moDefault.mapStations > 14 then moSetGetGui.zoomOutMax = moSetGetGui.zoomInMax;return;end;
	local checkZoom = moSetGetGui.zoomOutMax;
	for i = moSetGetGui.zoomInMax, checkZoom, 0.001 do
		if moGuiExtras:setMaxDisplayZoom(self) then			
			if moSetGetGui.pdaMenueSize > moSetGetGui.zoomOutMax then
				moSetGetGui.pdaMenueSize = moSetGetGui.zoomOutMax;
			end;
			if moSetGetGui.pdaMenueSize < moSetGetGui.zoomInMax then
				moSetGetGui.pdaMenueSize = moSetGetGui.zoomInMax;
			end;
			break;
		end;
	end;
end;

function moGuiExtras:setMaxDisplayZoom(self)
	local posBFruit = moSetGetGui.zoomOutMax/3*(moDefault.lengthFruitName)*1.03;
	local posBAmount = moSetGetGui.zoomOutMax/3*(moDefault.lengthAmount)*1.03;
	local posBStation = moSetGetGui.zoomOutMax/3*(moDefault.lengthStation)*1.03;
	local maxDisplay = 0.232+posBFruit+posBAmount+posBStation;
	local display = moSetGetGui.lsSpeedHudX+0.175; --1.00 !!!
	if maxDisplay > display then		
		moSetGetGui.zoomOutMax = moSetGetGui.zoomOutMax-0.001;		
		if tonumber(moSetGetGui.zoomOutMax) == tonumber(moSetGetGui.zoomInMax) then return true;end;
		return false;		
	end;
	return true;
end;

function moGuiExtras:getMoneyFormat(price)
	--if string.len(price) >= 8 then
	--	local splitPrice = Utils.splitString(".", price);
	--	if splitPrice ~= nil and splitPrice[1] ~= nil and splitPrice[2] ~= nil then
	--		return ((splitPrice[1]/1000).. ".".. splitPrice[2]);
	--	end;
	--end;
	--g_i18n:formatMoney(price);
	if string.len(price) >= 8 then
		local replacePrice1 = string.sub (price, string.len(price)-6);		
		local replacePrice2 = string.sub (price, 0, string.len(price)-7);		
		return (replacePrice2.. ".".. replacePrice1);
	end;
	return price;
end;

function moGuiExtras:getMilliSecondsToHours(sMilliSeconds)
	local nMilliSeconds = tonumber(sMilliSeconds);
	if nMilliSeconds == 0 then	
		return "0";
	else
		local nHours = string.format("%02.f", floor(nMilliSeconds/3600000));	
		return nHours;
	end
end

function moGuiExtras:getRandomColor(wert1, wert2)
	return random(wert1, wert2), random(wert1, wert2), random(wert1, wert2);
end;

function moGuiExtras:setSlotPositionenDouble(self, slot, plus)	
	local size = moGuiMiniPdaSlots.values[slot].size;
	local distanceDif = moGuiMiniPdaSlots.values[slot].distanceDif; --fillcontainer <----> filllevel
	local slotLength = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(moGuiMiniPdaSlots.values[slot].length+moSetGetGui.screenAspectRatio);	
	local lastWidth = moGuiMiniPdaSlots.values[slot].openLastWidth;	
	if plus then
		if moGuiMiniPdaSlots.values[slot].openX+(slotLength-0.003)+lastWidth > 1.0 then
			moGuiMiniPdaSlots.values[slot].openX = moGuiMiniPdaSlots.values[slot].openX-(slotLength-0.003);			
		end;
		moGuiMiniPdaSlots.values[slot].openLastWidth = lastWidth+(slotLength+distanceDif);
	else
		--if moGuiMiniPdaSlots.values[slot].openX+lastWidth < 1.0 then
			--moGuiMiniPdaSlots.values[slot].openX = moGuiMiniPdaSlots.values[slot].openX+(slotLength-0.003);
			moGuiMiniPdaSlots.values[slot].openLastWidth = lastWidth-(slotLength+distanceDif);
		--end;
	end;	
	moMouseClickAreas:setSlotCfg(self, slot);
end;

function moGuiExtras:setSlotPositionen(self, slot, new)	
	local slotName = MultiOverlayV2:getSlotName(slot);
	local widthNext = 0;
	local size = moGuiMiniPdaSlots.values[slot].size;
	if slotName == "bestprice" then widthNext = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(moGeneralSettings.lengthStationName+moSetGetGui.screenAspectRatio);end;	
	local distanceDif = moGuiMiniPdaSlots.values[slot].distanceDif; --fillcontainer <----> filllevel
	local slotLength = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(moGuiMiniPdaSlots.values[slot].length+moSetGetGui.screenAspectRatio);	
	moGuiMiniPdaSlots.values[slot].openLastWidth = slotLength+distanceDif+widthNext;		
	if new then		
		moGuiMiniPdaSlots.values[slot].openX = moGuiMiniPdaSlots.defaultOpenX;
		if moGuiMiniPdaSlots.values[slot].openX > 0.5 then 
			moGuiMiniPdaSlots.values[slot].openX = moGuiMiniPdaSlots.defaultOpenX-slotLength-0.003-widthNext;
			if slotName == "fieldsprice" then moGuiMiniPdaSlots.values[slot].maxProSwitch = 20;end;
		end;
		moGuiMiniPdaSlots.values[slot].openY = moGuiMiniPdaSlots.defaultOpenY;
	else
		--if moGuiMiniPdaSlots.values[slot].openX > 0.5 then moGuiMiniPdaSlots.values[slot].openX = moGuiMiniPdaSlots.defaultOpenX-slotLength;end;
	end;
	moMouseClickAreas:setSlotCfg(self, slot);
end;

function moGuiExtras:setSlotMaxProSwitch(self, slot)	
	local objects = moGuiMiniPdaSlots.values[slot].foundObjects/moGuiMiniPdaSlots.values[slot].maxProSwitch;
	local maxSwitch = moSetGetGui:round(objects+0.5);	
	if maxSwitch <= 1 then maxSwitch = 1;end;
	moGuiMiniPdaSlots.values[slot].maxSwitch = maxSwitch;	
	if moGuiMiniPdaSlots.values[slot].switch > maxSwitch then moGuiMiniPdaSlots.values[slot].switch = 1;end;
end;

function moGuiExtras:setSlotFirstEndObjects(self, slot)	
	if moGuiMiniPdaSlots.values[slot].switch == 1 then moGuiMiniPdaSlots.values[slot].firstObject = 1;moGuiMiniPdaSlots.values[slot].endObject = moGuiMiniPdaSlots.values[slot].maxProSwitch;end;
	if moGuiMiniPdaSlots.values[slot].switch > 1 then moGuiMiniPdaSlots.values[slot].firstObject = (moGuiMiniPdaSlots.values[slot].switch-1)*moGuiMiniPdaSlots.values[slot].maxProSwitch+(1);moGuiMiniPdaSlots.values[slot].endObject = moGuiMiniPdaSlots.values[slot].switch*moGuiMiniPdaSlots.values[slot].maxProSwitch;end;
	if moGuiMiniPdaSlots.values[slot].endObject > moGuiMiniPdaSlots.values[slot].foundObjects then moGuiMiniPdaSlots.values[slot].endObject = moGuiMiniPdaSlots.values[slot].foundObjects;end;
end;

function moGuiExtras:closeOpenSlot(self, slot, close, open)
	moGuiMiniPdaSlots.isSeeSmallDraw = false;							
	moGuiMiniPdaSlots.seeSmallDrawEnd = 350;
	if close and not open and moGuiMiniPdaSlots.values[slot].isOpen then		
		if moGuiMiniPdaSlots.values[slot].setMouseCursorOn then moSetGetKeyMouseEvent:setMouseCursorAndFrozen(self, false);end;
		if moGuiMiniPdaSlots.values[slot].closeOpenHud then 
			moGuiMiniPdaSlots.values[slot].isOpen = false;
			if moGuiMiniPdaSlots.values[slot].closeAllHud then moGuiExtras:setGetCloseAllHud(self, slot, false);end;
		end;
		return;
	end;
	if not close and open and not moGuiMiniPdaSlots.values[slot].isOpen then
		moGuiMiniPdaSlots.values[slot].isOpen = true;
		MultiOverlayV2:setSlotUpdate(self, slot);
		if moGuiMiniPdaSlots.values[slot].setMouseCursorOn then moSetGetKeyMouseEvent:setMouseCursorAndFrozen(self, true);end;		
		if moGuiMiniPdaSlots.values[slot].closeOpenHud then			
			if moGuiMiniPdaSlots.values[slot].closeAllHud then moGuiExtras:setGetCloseAllHud(self, slot, true);end;
		end;
		return;
	end;
	if close and open then
		if moGuiMiniPdaSlots.values[slot].isOpen then
			if moGuiMiniPdaSlots.values[slot].setMouseCursorOn then moSetGetKeyMouseEvent:setMouseCursorAndFrozen(self, false);end;
			if moGuiMiniPdaSlots.values[slot].closeOpenHud then 
				moGuiMiniPdaSlots.values[slot].isOpen = false;
				if moGuiMiniPdaSlots.values[slot].closeAllHud then moGuiExtras:setGetCloseAllHud(self, slot, false);end;
			end;
			return;			
		else
			moGuiMiniPdaSlots.values[slot].isOpen = true;
			MultiOverlayV2:setSlotUpdate(self, slot);
			if moGuiMiniPdaSlots.values[slot].setMouseCursorOn then moSetGetKeyMouseEvent:setMouseCursorAndFrozen(self, true);end;			
			if moGuiMiniPdaSlots.values[slot].closeOpenHud then 				
				if moGuiMiniPdaSlots.values[slot].closeAllHud then moGuiExtras:setGetCloseAllHud(self, slot, true);end;
			end;
			return;			
		end;
	end;
end;

function moGuiExtras:setGetCloseAllHud(self, slot, disable)	
	local helpText = moSetGetGui.helpText;
	local miniMap = moSetGetGui.miniMap.on;
	local wtmHud = moSetGetGui.wtmHud.on;
	local vsHud = moSetGetGui.vsHud.on;
	if disable then
		if helpText then moGuiExtras:setGetHelpText(self, false);end;		
		if miniMap then moGuiExtras:setGetMiniMap(self, false);end;		
		if wtmHud then moGuiExtras:setGetWtmHud(self, false);end;		
		if vsHud then moGuiExtras:setGetVsHud(self, false);end;
		if slot ~= nil and slot ~= 0 then
			moGuiMiniPdaSlots.values[slot].closeAllHudTemp = {helpText, miniMap, wtmHud, vsHud};
		else
			moSetGetGui.closeAllHudTemp = {helpText, miniMap, wtmHud, vsHud};
		end;
	else
		if moSetGetGui.closeAllHudTemp[1] then moGuiExtras:setGetHelpText(self, true);end;
		if moSetGetGui.closeAllHudTemp[2] then moGuiExtras:setGetMiniMap(self, true);end;
		if moSetGetGui.closeAllHudTemp[3] then moGuiExtras:setGetWtmHud(self, true);end;
		if moSetGetGui.closeAllHudTemp[4] then moGuiExtras:setGetVsHud(self, true);end;
		if slot ~= nil and slot ~= 0 then
			moGuiMiniPdaSlots.values[slot].closeAllHudTemp = {true, true, true, true};			
		else
			moSetGetGui.closeAllHudTemp = {true, true, true, true};
		end;
	end;
end;

function moGuiExtras:setGetHelpText(self, enable)
	if enable then 
		g_currentMission.showHelpText = true;
		moSetGetGui.helpText = true;
	else
		g_currentMission.showHelpText = false;
		moSetGetGui.helpText = false;
	end;
end;

function moGuiExtras:setGetMiniMap(self, enable)
	if moSetGetGui.miniMap.binding then
		if enable then
			g_currentMission.ingameMap.isVisible = true;
			moSetGetGui.miniMap.on = true;
		else
			g_currentMission.ingameMap.isVisible = false;
			moSetGetGui.miniMap.on = false;
		end;
	end;
end;

function moGuiExtras:setGetWtmHud(self, enable)
	if moSetGetGui.wtmHud.binding then
		if enable then	
			moSetGetGui.wtmHud.on = true;
			g_currentMission.moneyBackgroundOverlay.visible = true;
			g_currentMission.moneyIconOverlay.visible = true;
			g_currentMission.moneyTextSize = moSetGetGui.wtmHud.moneyTextSize;		
			g_currentMission.renderTime = true;
			g_currentMission.showWeatherForecast = true;		
		else
			moSetGetGui.wtmHud.on = false;		
			g_currentMission.renderTime = false;
			g_currentMission.moneyIconOverlay.visible = false;		
			g_currentMission.moneyTextSize = 0.0;
			g_currentMission.moneyBackgroundOverlay.visible = false;
			g_currentMission.showWeatherForecast = false;
		end;
	end;
end;

function moGuiExtras:setGetVsHud(self, enable)
	if moSetGetGui.vsHud.binding then
		if enable then
			g_currentMission.showVehicleSchema = true;
			g_currentMission.showVehicleInfo = true;
			moSetGetGui.vsHud.on = true;
		else
			g_currentMission.showVehicleSchema= false;
			g_currentMission.showVehicleInfo = false;		
			moSetGetGui.vsHud.on = false;
		end;
	end;
end;
--vehicleSchemaOverlayScaleY
--vehicleXZPosCompressionParams table
--vehicleYPosCompressionParams table
--vehicleSellingPointBase table
--vehicleHudPosY
--vehicleBaseHudWidth
--vehicleSchemaOverlayScaleX
--vehicleBaseHudHeight
--vehicleHudScale
--vehicleHudPosX
--speedHudPosY
--speedUnitTextPosY
--speedTextPosX
--speedUnitTextPosX
--speedTextPosY
--speedHudPosX
--speedUnitTextSize
--speedHud table
--speedTextSize


function moGuiExtras:writeLogObjects(self)
	print("----".. tostring(MultiOverlayV2.metadata.title).. " logSearchMap Objects----")
	print(" found animals(sr/ls): ".. tostring(moGeneralSettings.foundAnimals))
	print(" found other: ".. tostring(moGeneralSettings.foundOther))
	print(" found fs: ".. tostring(moGeneralSettings.foundFabrikscript))
	if moGeneralSettings.upkReady then print(" found upk: ".. tostring(moGeneralSettings.foundUpk));end;
	print(" found mapscripts: ".. tostring(moGeneralSettings.foundScripts))
	if moGeneralSettings.notFoundPalSammler ~= 0 then
		print(" !! ".. tostring(moGeneralSettings.notFoundPalSammler.. " PalSammler not assigned !!"))
	end;
	local count = 0;
	local logTxt = "";
	if moStationes ~= nil then
		print(" --optional replace StationNames at language_...xml - <text name=station_StationBiomassHeatingPlant text=Bio Hz. />")		
		for k,v in pairs(moStationes) do
			count = count+1;			
			local stationName = moStationes[k].station;
			if string.find(stationName, " ") then
				stationName = string.gsub(stationName, " ", "_");
			end;
			logTxt = logTxt.. stationName.. "(inGame:".. moStationes[k].stationName.. "),"
			if count == 5 then
				print(" found MapStationes: ".. tostring(logTxt))
				logTxt = "";
				count = 0;
			end;
		end;
		if string.len(logTxt) > 0 then
			print(" found MapStationes: ".. tostring(logTxt))
		end;
	end;
	logTxt = "";
	count = 0;
	if moFillTypes ~= nil then
		print(" --optional replace FruitNames at language_...xml - <text name=fruit_maize text=Mais />")
		for k,v in pairs(moFillTypes) do
			count = count+1;
			local fruitName = moFillTypes[k].descName;
			if string.find(fruitName, " ") then
				fruitName = string.gsub(fruitName, " ", "_");
			end;
			logTxt = logTxt.. fruitName.. "(inGame:".. moFillTypes[k].fruitName.. "),"
			if count == 8 then
				print(" found MapFruits: ".. tostring(logTxt))
				logTxt = "";
				count = 0;
			end;
		end;
		if string.len(logTxt) > 0 then
			print(" found MapFruits: ".. tostring(logTxt))
		end;
	end;
	
end;

moGuiExtras.colors = {
	artDesign =       	{ 255/255, 255/255, 255/255, 1.00 };
	artDesignDisabled = { 255/255, 255/255, 255/255, 0.80 };
	artDesignSilo =     { 	0/255,   0/255,   0/255, 1.00 };
	artDesignPrice =    { 255/255, 255/255, 255/255, 1.00 };
	artDesignBestPrice ={ 	0/255, 255/255,   0/255, 0.80 };
	artDesignDemand =   {   4/255,  98/255, 180/255, 1.00 }; 
	own =       		{ 255/255, 255/255, 255/255, 1.00 };
	ownDisabled =   	{ 255/255, 255/255, 255/255, 0.80 };
	ownSilo =       	{ 	0/255,   0/255,   0/255, 1.00 };
	ownPrice =      	{ 255/255, 255/255, 255/255, 1.00 };
	ownBestPrice =  	{ 	0/255, 255/255,   0/255, 0.80 };
	ownDemand =     	{   4/255,  98/255, 180/255, 1.00 }; 	
	randomValues =  	{ 255/255, 255/255, 255/255, 1.00 };
	randomValuesOff =	{ 255/255, 255/255, 255/255, 0.80 };
	transparent =   	{  33/255,  48/255,  24/255, 0.50 };	
	darkYellow =   		{ 255/255, 161/255,  17/255, 1.00 };
	darkYellowOff =  	{ 255/255, 161/255,  17/255, 0.80 };
	white =         	{ 255/255, 255/255, 255/255, 1.00 };
	whiteBestPrice =	{ 255/255, 255/255, 255/255, 1.00 };
	whiteInactive = 	{ 255/255, 255/255, 255/255, 0.75 };
	whiteDisabled = 	{ 255/255, 255/255, 255/255, 0.15 };
	hover =         	{   4/255,  98/255, 180/255, 1.00 };
	hoverBestPrice =	{   4/255,  98/255, 180/255, 0.70 };
	darkBlue =	 		{ 	0/255,   0/255, 255/255, 1.00 };
	activeGreen =   	{  43/255, 205/255,  10/255, 1.00 }; 
	activeRed =    	 	{ 153/255,  22/255,  19/255, 1.00 }; 
	closeRed =      	{ 116/255,   0/255,   0/255, 1.00 }; 
	warningRed =    	{ 222/255,   2/255,   3/255, 1.00 };
	red =      			{ 255/255,   0/255,   0/255, 1.00 };
	redDisabled =   	{ 255/255,   0/255,   0/255, 0.80 };
	shadow =        	{   4/255,   4/255,   4/255, 1.00 }; 
	textDark =      	{   1/255,   1/255,   1/255, 1.00 };
	yellow =        	{ 255/255, 255/255,   0/255, 1.00 };
	yellowDisabled =	{ 255/255, 255/255,   0/255, 0.80 };
	yellowGreen =		{ 154/255, 205/255,  50/255, 1.00 };
	yellow1 =			{ 238/255, 221/255, 130/255, 1.00 };
	gold =				{ 255/255, 215/255,   0/255, 1.00 };
	green =        		{ 	0/255, 255/255,   0/255, 1.00 };
	darkOliveGreen =    {  85/255, 107/255,  47/255, 1.00 };
	greenDisabled = 	{ 	0/255, 255/255,   0/255, 0.80 };
	darkGreen = 		{ 	0/255, 100/255,   0/255, 1.00 };
	lightGreen =   		{ 144/255, 238/255, 144/255, 1.00 };
	chartreuse4 =		{ 69/255,  139/255,   0/255, 1.00 };
	happylooser =   	{ 143/255, 188/255, 143/255, 1.00 };---
	happylooserOff= 	{ 143/255, 188/255, 143/255, 0.80 };---
	gray = 				{ 190/255, 190/255, 190/255, 1.00 };
	black =        		{ 	0/255,   0/255,   0/255, 1.00 };
	orange =        	{ 255/255, 165/255,   0/255, 1.00 };
	orangeRed =        	{ 255/255,  55/255,   0/255, 1.00 };
	khaki =         	{ 240/255, 230/255, 140/255, 1.00 };
	ls15 =          	{   0/255, 255/255, 255/255, 1.00 };
	ls15Disabled =  	{   0/255, 255/255, 255/255, 0.80 };
	mangenta =  		{ 255/255, 	 0/255, 255/255, 1.00 };
	deepPink =  		{ 255/255, 020/255, 147/255, 1.00 };
	purple =  			{ 160/255, 032/255, 240/255, 1.00 };
};